Skip to content

Display, format, sort, and filter time values correctly by using the time cell type. Edit times via the cell editor.

The time cell type formats time values using a configurable format string. Use it for scheduling, logging, or any time-based data.

Overview

The time cell type lets you treat cell values as times: format how they are displayed and validate input. Handsontable supports two configurations: the object-style configuration using the native Intl.DateTimeFormat API (recommended), and a string-style configuration using Moment.js (deprecated).

Time cell type demo

In the following demo, the Start, Break start, and End columns use the time cell type with different formats: short style, custom format with hours, minutes, and seconds, and format with day period. Use the locale selector to see how each format varies by locale.

JavaScript
import Handsontable from 'handsontable/base';
import { registerAllModules } from 'handsontable/registry';
// Register all Handsontable's modules.
registerAllModules();
const container = document.querySelector('#example1');
const dropdown = document.querySelector('#localeDropdown');
const trigger = document.querySelector('#localeTrigger');
const menu = document.querySelector('#localeMenu');
const label = document.querySelector('#localeLabel');
7 collapsed lines
const data = [
{ shift: 'Morning', start: '09:00', breakStart: '12:00', end: '17:00' },
{ shift: 'Afternoon', start: '13:30', breakStart: '16:00', end: '21:00' },
{ shift: 'Night', start: '22:00', breakStart: '01:00', end: '06:00' },
{ shift: 'Split', start: '08:00', breakStart: '12:30', end: '20:00' },
{ shift: 'Short day', start: '10:00', breakStart: '13:00', end: '15:00' },
];
const hot = new Handsontable(container, {
data,
colHeaders: ['Shift', 'Start', 'Break start', 'End'],
31 collapsed lines
columns: [
{
type: 'text',
data: 'shift',
},
{
type: 'intl-time',
data: 'start',
timeFormat: {
timeStyle: 'short',
},
},
{
type: 'intl-time',
data: 'breakStart',
timeFormat: {
hour: '2-digit',
minute: '2-digit',
second: '2-digit',
},
},
{
type: 'intl-time',
data: 'end',
timeFormat: {
hour: 'numeric',
hourCycle: 'h12',
dayPeriod: 'short',
},
},
],
columnSorting: true,
filters: true,
dropdownMenu: true,
height: 'auto',
licenseKey: 'non-commercial-and-evaluation',
autoWrapRow: true,
autoWrapCol: true,
});
// Handle dropdown toggle
trigger.addEventListener('click', () => {
const isOpen = !menu.hidden;
menu.hidden = isOpen;
trigger.setAttribute('aria-expanded', String(!isOpen));
});
// Handle locale selection
menu.addEventListener('click', (e) => {
const item = e.target.closest('li[data-value]');
if (item) {
label.textContent = item.textContent.trim();
menu.querySelectorAll('li').forEach((li) => li.setAttribute('aria-selected', 'false'));
item.setAttribute('aria-selected', 'true');
menu.hidden = true;
trigger.setAttribute('aria-expanded', 'false');
hot.updateSettings({ locale: item.dataset.value });
}
});
// Close dropdown when clicking outside
document.addEventListener('click', (e) => {
if (!dropdown.contains(e.target)) {
menu.hidden = true;
trigger.setAttribute('aria-expanded', 'false');
}
});
// Close dropdown on Escape key
document.addEventListener('keydown', (e) => {
if (e.key === 'Escape' && !menu.hidden) {
menu.hidden = true;
trigger.setAttribute('aria-expanded', 'false');
trigger.focus();
}
});
TypeScript
import Handsontable from 'handsontable/base';
import { registerAllModules } from 'handsontable/registry';
// Register all Handsontable's modules.
registerAllModules();
const container = document.querySelector('#example1')!;
const dropdown = document.querySelector('#localeDropdown')!;
const trigger = document.querySelector('#localeTrigger')!;
const menu = document.querySelector('#localeMenu')!;
const label = document.querySelector('#localeLabel')!;
7 collapsed lines
const data = [
{ shift: 'Morning', start: '09:00', breakStart: '12:00', end: '17:00' },
{ shift: 'Afternoon', start: '13:30', breakStart: '16:00', end: '21:00' },
{ shift: 'Night', start: '22:00', breakStart: '01:00', end: '06:00' },
{ shift: 'Split', start: '08:00', breakStart: '12:30', end: '20:00' },
{ shift: 'Short day', start: '10:00', breakStart: '13:00', end: '15:00' },
];
const hot = new Handsontable(container, {
data,
colHeaders: ['Shift', 'Start', 'Break start', 'End'],
31 collapsed lines
columns: [
{
type: 'text',
data: 'shift',
},
{
type: 'intl-time',
data: 'start',
timeFormat: {
timeStyle: 'short',
},
},
{
type: 'intl-time',
data: 'breakStart',
timeFormat: {
hour: '2-digit',
minute: '2-digit',
second: '2-digit',
},
},
{
type: 'intl-time',
data: 'end',
timeFormat: {
hour: 'numeric',
hourCycle: 'h12',
dayPeriod: 'short',
},
},
],
columnSorting: true,
filters: true,
dropdownMenu: true,
height: 'auto',
licenseKey: 'non-commercial-and-evaluation',
autoWrapRow: true,
autoWrapCol: true,
});
// Handle dropdown toggle
trigger.addEventListener('click', () => {
const isOpen = !menu.hidden;
menu.hidden = isOpen;
trigger.setAttribute('aria-expanded', String(!isOpen));
});
// Handle locale selection
menu.addEventListener('click', (e) => {
const item = (e.target as HTMLElement).closest('li[data-value]') as HTMLLIElement | null;
if (item) {
label.textContent = item.textContent!.trim();
menu.querySelectorAll('li').forEach((li) => li.setAttribute('aria-selected', 'false'));
item.setAttribute('aria-selected', 'true');
menu.hidden = true;
trigger.setAttribute('aria-expanded', 'false');
hot.updateSettings({ locale: item.dataset.value });
}
});
// Close dropdown when clicking outside
document.addEventListener('click', (e) => {
if (!dropdown.contains(e.target as Node)) {
menu.hidden = true;
trigger.setAttribute('aria-expanded', 'false');
}
});
// Close dropdown on Escape key
document.addEventListener('keydown', (e) => {
if (e.key === 'Escape' && !menu.hidden) {
menu.hidden = true;
trigger.setAttribute('aria-expanded', 'false');
trigger.focus();
}
});
HTML
<div class="example-controls-container">
<div class="controls">
<div class="theme-dropdown" id="localeDropdown">
<button
class="theme-dropdown-trigger"
type="button"
id="localeTrigger"
aria-haspopup="listbox"
aria-expanded="false"
>
<span id="localeLabel">English (United States)</span>
<svg class="theme-dropdown-chevron" aria-hidden="true" width="12" height="12" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"><path d="M6 9l6 6l6 -6"/></svg>
</button>
<ul class="theme-dropdown-menu" role="listbox" id="localeMenu" hidden>
<li role="option" data-value="ar-AR">Arabic (Global)</li>
<li role="option" data-value="cs-CZ">Czech (Czechia)</li>
<li role="option" data-value="de-CH">German (Switzerland)</li>
<li role="option" data-value="de-DE">German (Germany)</li>
<li role="option" data-value="en-US" aria-selected="true">English (United States)</li>
<li role="option" data-value="es-MX">Spanish (Mexico)</li>
<li role="option" data-value="fa-IR">Persian (Iran)</li>
<li role="option" data-value="fr-FR">French (France)</li>
<li role="option" data-value="hr-HR">Croatian (Croatia)</li>
<li role="option" data-value="it-IT">Italian (Italy)</li>
<li role="option" data-value="ja-JP">Japanese (Japan)</li>
<li role="option" data-value="ko-KR">Korean (Korea)</li>
<li role="option" data-value="lv-LV">Latvian (Latvia)</li>
<li role="option" data-value="nb-NO">Norwegian Bokmal (Norway)</li>
<li role="option" data-value="nl-NL">Dutch (Netherlands)</li>
<li role="option" data-value="pl-PL">Polish (Poland)</li>
<li role="option" data-value="pt-BR">Portuguese (Brazil)</li>
<li role="option" data-value="ru-RU">Russian (Russia)</li>
<li role="option" data-value="sr-SP">Serbian Latin (Serbia)</li>
<li role="option" data-value="zh-CN">Chinese (Simplified, China)</li>
<li role="option" data-value="zh-TW">Chinese (Traditional, Taiwan)</li>
</ul>
</div>
</div>
</div>
<div id="example1"></div>

Use the time cell type

Use the object-style configuration by setting the type option to 'intl-time' and timeFormat to an object (recommended). The locale is controlled via the locale option.

// set the time cell type for the entire grid (Intl, recommended)
type: 'intl-time',
locale: 'en-US',
timeFormat: {
hour: 'numeric',
minute: '2-digit',
second: '2-digit',
hour12: true
},
// set the time cell type for a single column
columns: [
{
type: 'intl-time',
locale: 'en-US',
timeFormat: {
timeStyle: 'medium'
}
}
],
// set the time cell type for a single cell
cell: [
{
row: 0,
col: 2,
type: 'intl-time',
locale: 'en-US',
timeFormat: { hour: '2-digit', minute: '2-digit', hour12: true }
}
],

For intl-time cells, source data must be in 24-hour time format (HH:mm, HH:mm:ss, or HH:mm:ss.SSS) for times to work correctly. The timeFormat object only affects how times are displayed; sorting and filtering rely on the underlying value.

Format times

To control how times are displayed in cell renderers, use the timeFormat option.

Since Handsontable 17.0, the recommended approach is the object form of timeFormat with the intl-time cell type, which uses the native Intl.DateTimeFormat API. The locale is controlled separately via the locale option.

The timeFormat option accepts properties of Intl.DateTimeFormat options relevant to time. Use it with type: 'intl-time'.

columns: [
{
type: 'intl-time',
locale: 'en-US',
timeFormat: {
hour: 'numeric',
minute: '2-digit',
second: '2-digit',
hour12: true
}
},
{
type: 'intl-time',
locale: 'de-DE',
timeFormat: {
timeStyle: 'medium'
}
}
]

Time-specific options

Style shortcuts:

PropertyPossible valuesDescription
timeStyle'full', 'long', 'medium', 'short'Time formatting style (hour, minute, second, timeZoneName)

Time component options:

PropertyPossible valuesDescription
hour'numeric', '2-digit'Hour representation
minute'numeric', '2-digit'Minute representation
second'numeric', '2-digit'Second representation
fractionalSecondDigits1, 2, 3Fraction-of-second digits
dayPeriod'narrow', 'short', 'long'Day period (e.g. “am”)
timeZoneName'long', 'short', 'shortOffset', 'longOffset', 'shortGeneric', 'longGeneric'Time zone display

Locale and other options:

PropertyPossible valuesDescription
localeMatcher'best fit' (default), 'lookup'Locale matching algorithm
timeZoneIANA time zone (e.g. 'UTC', 'America/New_York')Time zone for formatting
hour12true, false12-hour vs 24-hour time
hourCycle'h11', 'h12', 'h23', 'h24'Hour cycle
formatMatcher'basic', 'best fit' (default)Format matching algorithm

For a complete reference, see the timeFormat API documentation or MDN: Intl.DateTimeFormat.

Using string format with Moment.js (deprecated)

The time cell type with a string timeFormat is still supported but will be removed in next major release.

Deprecated options:

OptionDescriptionReplacement
timeFormat (string)Moment.js format (e.g. 'h:mm:ss a')Use intl-time with timeFormat object (see above)
correctFormatAuto-correct entered time to match formatMay be handled by valueParser and/or valueSetter options

Migration example:

// Before (deprecated)
columns: [{
type: 'time',
timeFormat: 'h:mm:ss a',
}]
// After (recommended)
columns: [{
type: 'intl-time',
locale: 'en-US',
timeFormat: {
hour: 'numeric',
minute: '2-digit',
second: '2-digit',
hour12: true,
}
}]

Editor behavior

The timeFormat option controls how times are displayed in the cell. The editor may show the value in a normalized form; for intl-time, the underlying value remains in 24-hour format (HH:mm, HH:mm:ss, or HH:mm:ss.SSS).

Result

After configuring the time cell type, cells display time values formatted according to your timeFormat configuration. Source data is stored in 24-hour format (HH:mm, HH:mm:ss, or HH:mm:ss.SSS) regardless of the display format.

Related guides

Configuration options

Core methods

Hooks

React Data GridTime cell type

Use the time cell type to display, format, and validate values as times. The time cell type uses Moment.js as a time formatter.

Usage

To use the time cell type, set the type: 'time' option in the columns array or the cells function. The time cell uses Moment.js (opens new window) as the time formatter, therefore you must add the following required dependency:

<script src="https://cdn.jsdelivr.net/npm/moment@2.29.4/moment.min.js"></script>

All data entered into the time-typed cells is eventually validated against the default time format - h:mm:ss a, which translates to, for example, 9:30:00 am unless another format is provided as the timeFormat. If you enable the correctFormat configuration option, the values will be automatically formatted to match the desired time format.

TIP

By default, the values entered into the time-type column are not validated, so if you want them to display in the proper format, remember to call hot.validateCells() after the table initialization.

Basic example

import { useEffect, useRef } from 'react';
import { HotTable } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
import 'handsontable/styles/handsontable.css';
import 'handsontable/styles/ht-theme-main.css';

// register Handsontable's modules
registerAllModules();

const ExampleComponent = () => {
  const hotRef = useRef(null);

  useEffect(() => {
    const hot = hotRef.current?.hotInstance;

    hot?.validateCells();
  });

  return (
    <HotTable
      themeName="ht-theme-main"
      ref={hotRef}
      data={[
        ['Mercedes', 'A 160', 1332284400000, 6999.95],
        ['Citroen', 'C4 Coupe', '10 30', 8330],
        ['Audi', 'A4 Avant', '8:00 PM', 33900],
        ['Opel', 'Astra', 1332284400000, 7000],
        ['BMW', '320i Coupe', 1332284400000, 30500],
      ]}
      colHeaders={['Car', 'Model', 'Registration time', 'Price']}
      columnSorting={true}
      height="auto"
      autoWrapRow={true}
      autoWrapCol={true}
      licenseKey="non-commercial-and-evaluation"
      columns={[
        {
          type: 'text',
        },
        {
          // 2nd cell is simple text, no special options here
        },
        {
          type: 'time',
          timeFormat: 'h:mm:ss a',
          correctFormat: true,
        },
        {
          type: 'numeric',
          numericFormat: {
            pattern: '$0,0.00',
          },
        },
      ]}
    />
  );
};

export default ExampleComponent;

Skip to content

Display, format, sort, and filter time values correctly by using the time cell type. Edit times via the cell editor.

The time cell type formats time values using a configurable format string. Use it for scheduling, logging, or any time-based data.

Overview

The time cell type lets you treat cell values as times: format how they are displayed and validate input. Handsontable supports two configurations: the object-style configuration using the native Intl.DateTimeFormat API (recommended), and a string-style configuration using Moment.js (deprecated).

Time cell type demo

In the following demo, the Start, Break start, and End columns use the time cell type with different formats: short style, custom format with hours, minutes, and seconds, and format with day period. Use the locale selector to see how each format varies by locale.

Vue
<script setup lang="ts">
import { ref, onMounted, onBeforeUnmount, useTemplateRef } from 'vue';
import { HotTable } from '@handsontable/vue3';
import { registerAllModules } from 'handsontable/registry';
import type { GridSettings } from 'handsontable/settings';
// register Handsontable's modules
registerAllModules();
const localeOptions = [
{ value: 'ar-AR', label: 'Arabic (Global)' },
{ value: 'cs-CZ', label: 'Czech (Czechia)' },
{ value: 'de-CH', label: 'German (Switzerland)' },
{ value: 'de-DE', label: 'German (Germany)' },
{ value: 'en-US', label: 'English (United States)' },
{ value: 'es-MX', label: 'Spanish (Mexico)' },
{ value: 'fa-IR', label: 'Persian (Iran)' },
{ value: 'fr-FR', label: 'French (France)' },
{ value: 'hr-HR', label: 'Croatian (Croatia)' },
{ value: 'it-IT', label: 'Italian (Italy)' },
{ value: 'ja-JP', label: 'Japanese (Japan)' },
{ value: 'ko-KR', label: 'Korean (Korea)' },
{ value: 'lv-LV', label: 'Latvian (Latvia)' },
{ value: 'nb-NO', label: 'Norwegian Bokmal (Norway)' },
{ value: 'nl-NL', label: 'Dutch (Netherlands)' },
{ value: 'pl-PL', label: 'Polish (Poland)' },
{ value: 'pt-BR', label: 'Portuguese (Brazil)' },
{ value: 'ru-RU', label: 'Russian (Russia)' },
{ value: 'sr-SP', label: 'Serbian Latin (Serbia)' },
{ value: 'zh-CN', label: 'Chinese (Simplified, China)' },
{ value: 'zh-TW', label: 'Chinese (Traditional, Taiwan)' },
];
const hotRef = useTemplateRef<InstanceType<typeof HotTable>>('hotRef');
const dropdownRef = useTemplateRef<HTMLDivElement>('dropdownRef');
const isOpen = ref(false);
const locale = ref('en-US');
const selectedLabel = () => localeOptions.find((o) => o.value === locale.value)?.label;
const handleSelect = (value: string) => {
locale.value = value;
isOpen.value = false;
hotRef.value?.hotInstance?.updateSettings({ locale: value } as GridSettings);
};
const handleOutsideClick = (e: MouseEvent) => {
if (dropdownRef.value && !dropdownRef.value.contains(e.target as Node)) {
isOpen.value = false;
}
};
const handleEscape = (e: KeyboardEvent) => {
if (e.key === 'Escape') {
isOpen.value = false;
}
};
onMounted(() => {
document.addEventListener('click', handleOutsideClick);
document.addEventListener('keydown', handleEscape);
});
onBeforeUnmount(() => {
document.removeEventListener('click', handleOutsideClick);
document.removeEventListener('keydown', handleEscape);
});
const data = [
{ shift: 'Morning', start: '09:00', breakStart: '12:00', end: '17:00' },
{ shift: 'Afternoon', start: '13:30', breakStart: '16:00', end: '21:00' },
{ shift: 'Night', start: '22:00', breakStart: '01:00', end: '06:00' },
{ shift: 'Split', start: '08:00', breakStart: '12:30', end: '20:00' },
{ shift: 'Short day', start: '10:00', breakStart: '13:00', end: '15:00' },
];
const hotSettings = ref<GridSettings>({
data,
colHeaders: ['Shift', 'Start', 'Break start', 'End'],
locale: 'en-US',
columns: [
{
type: 'text',
data: 'shift',
},
{
type: 'intl-time',
data: 'start',
timeFormat: {
timeStyle: 'short',
},
},
{
type: 'intl-time',
data: 'breakStart',
timeFormat: {
hour: '2-digit',
minute: '2-digit',
second: '2-digit',
},
},
{
type: 'intl-time',
data: 'end',
timeFormat: {
hour: 'numeric',
hourCycle: 'h12',
dayPeriod: 'short',
},
},
],
columnSorting: true,
filters: true,
dropdownMenu: true,
height: 'auto',
autoWrapRow: true,
autoWrapCol: true,
licenseKey: 'non-commercial-and-evaluation',
});
</script>
<template>
<div id="example1">
<div class="example-controls-container">
<div class="controls">
<div class="theme-dropdown" ref="dropdownRef">
<button
class="theme-dropdown-trigger"
type="button"
aria-haspopup="listbox"
:aria-expanded="isOpen"
@click="isOpen = !isOpen"
>
<span>{{ selectedLabel() }}</span>
<svg class="theme-dropdown-chevron" aria-hidden="true" width="12" height="12" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"><path d="M6 9l6 6l6 -6"/></svg>
</button>
<ul v-if="isOpen" class="theme-dropdown-menu" role="listbox">
<li
v-for="opt in localeOptions"
:key="opt.value"
role="option"
:aria-selected="locale === opt.value"
@click="handleSelect(opt.value)"
>
{{ opt.label }}
</li>
</ul>
</div>
</div>
</div>
<HotTable ref="hotRef" :settings="hotSettings" />
</div>
</template>

Use the time cell type

Use the object-style configuration by setting the type option to 'intl-time' and timeFormat to an object (recommended). The locale is controlled via the locale option.

<script setup lang="ts">
import { ref } from 'vue';
import { HotTable } from '@handsontable/vue3';
import { registerAllModules } from 'handsontable/registry';
import type { GridSettings } from 'handsontable/settings';
registerAllModules();
// set the time cell type for the entire grid (Intl, recommended)
const hotSettings = ref<GridSettings>({
type: 'intl-time',
locale: 'en-US',
timeFormat: {
hour: 'numeric',
minute: '2-digit',
second: '2-digit',
hour12: true
},
licenseKey: 'non-commercial-and-evaluation',
});
// set the time cell type for a single column
const hotSettingsColumn = ref<GridSettings>({
columns: [
{
type: 'intl-time',
locale: 'en-US',
timeFormat: { timeStyle: 'medium' }
}
],
licenseKey: 'non-commercial-and-evaluation',
});
// set the time cell type for a single cell
const hotSettingsCell = ref<GridSettings>({
cell: [
{
row: 0,
col: 2,
type: 'intl-time',
locale: 'en-US',
timeFormat: { hour: '2-digit', minute: '2-digit', hour12: true }
}
],
licenseKey: 'non-commercial-and-evaluation',
});
</script>

For intl-time cells, source data must be in 24-hour time format (HH:mm, HH:mm:ss, or HH:mm:ss.SSS) for times to work correctly. The timeFormat object only affects how times are displayed; sorting and filtering rely on the underlying value.

Format times

To control how times are displayed in cell renderers, use the timeFormat option.

Since Handsontable 17.0, the recommended approach is the object form of timeFormat with the intl-time cell type, which uses the native Intl.DateTimeFormat API. The locale is controlled separately via the locale option.

The timeFormat option accepts properties of Intl.DateTimeFormat options relevant to time. Use it with type: 'intl-time'.

<script setup lang="ts">
import { ref } from 'vue';
import { HotTable } from '@handsontable/vue3';
import { registerAllModules } from 'handsontable/registry';
import type { GridSettings } from 'handsontable/settings';
registerAllModules();
const hotSettings = ref<GridSettings>({
columns: [
{
type: 'intl-time',
locale: 'en-US',
timeFormat: {
hour: 'numeric',
minute: '2-digit',
second: '2-digit',
hour12: true
}
},
{
type: 'intl-time',
locale: 'de-DE',
timeFormat: { timeStyle: 'medium' }
}
],
licenseKey: 'non-commercial-and-evaluation',
});
</script>
<template>
<HotTable :settings="hotSettings" />
</template>

Time-specific options

Style shortcuts:

PropertyPossible valuesDescription
timeStyle'full', 'long', 'medium', 'short'Time formatting style (hour, minute, second, timeZoneName)

Time component options:

PropertyPossible valuesDescription
hour'numeric', '2-digit'Hour representation
minute'numeric', '2-digit'Minute representation
second'numeric', '2-digit'Second representation
fractionalSecondDigits1, 2, 3Fraction-of-second digits
dayPeriod'narrow', 'short', 'long'Day period (e.g. “am”)
timeZoneName'long', 'short', 'shortOffset', 'longOffset', 'shortGeneric', 'longGeneric'Time zone display

Locale and other options:

PropertyPossible valuesDescription
localeMatcher'best fit' (default), 'lookup'Locale matching algorithm
timeZoneIANA time zone (e.g. 'UTC', 'America/New_York')Time zone for formatting
hour12true, false12-hour vs 24-hour time
hourCycle'h11', 'h12', 'h23', 'h24'Hour cycle
formatMatcher'basic', 'best fit' (default)Format matching algorithm

For a complete reference, see the timeFormat API documentation or MDN: Intl.DateTimeFormat.

Using string format with Moment.js (deprecated)

The time cell type with a string timeFormat is still supported but will be removed in next major release.

Deprecated options:

OptionDescriptionReplacement
timeFormat (string)Moment.js format (e.g. 'h:mm:ss a')Use intl-time with timeFormat object (see above)
correctFormatAuto-correct entered time to match formatMay be handled by valueParser and/or valueSetter options

Migration example:

// Before (deprecated)
columns: [{
type: 'time',
timeFormat: 'h:mm:ss a',
}]
// After (recommended)
columns: [{
type: 'intl-time',
locale: 'en-US',
timeFormat: {
hour: 'numeric',
minute: '2-digit',
second: '2-digit',
hour12: true,
}
}]

Editor behavior

The timeFormat option controls how times are displayed in the cell. The editor may show the value in a normalized form; for intl-time, the underlying value remains in 24-hour format (HH:mm, HH:mm:ss, or HH:mm:ss.SSS).

Result

After configuring the time cell type, cells display time values formatted according to your timeFormat configuration. Source data is stored in 24-hour format (HH:mm, HH:mm:ss, or HH:mm:ss.SSS) regardless of the display format.

Related guides

Configuration options

Core methods

Hooks

Angular Data GridTime cell type

Use the time cell type to display, format, and validate values as times. The time cell type uses Moment.js as a time formatter.

Usage

To use the time cell type, set the type: 'time' option in the columns array or the cells function. The time cell uses Moment.js (opens new window) as the time formatter, therefore you must add the following required dependency:

<script src="https://cdn.jsdelivr.net/npm/moment@2.29.4/moment.min.js"></script>

All data entered into the time-typed cells is eventually validated against the default time format - h:mm:ss a, which translates to, for example, 9:30:00 am unless another format is provided as the timeFormat. If you enable the correctFormat configuration option, the values will be automatically formatted to match the desired time format.

TIP

By default, the values entered into the time-type column are not validated, so if you want them to display in the proper format, remember to call hot.validateCells() after the table initialization.

Basic example

/* file: app.component.ts */
import { AfterViewInit, Component, ViewChild } from '@angular/core';
import { GridSettings, HotTableComponent } from '@handsontable/angular-wrapper';

@Component({
  selector: 'example1-time-cell-type',
  standalone: false,
  template: ` <div>
    <hot-table [data]="data" [settings]="gridSettings"></hot-table>
  </div>`,
})
export class Example1TimeCellTypeComponent implements AfterViewInit {
  @ViewChild(HotTableComponent, { static: false }) readonly hotTable!: HotTableComponent;

  readonly data = [
    ['Mercedes', 'A 160', 1332284400000, 6999.95],
    ['Citroen', 'C4 Coupe', '10 30', 8330],
    ['Audi', 'A4 Avant', '8:00 PM', 33900],
    ['Opel', 'Astra', 1332284400000, 7000],
    ['BMW', '320i Coupe', 1332284400000, 30500],
  ];

  readonly gridSettings: GridSettings = {
    colHeaders: ['Car', 'Model', 'Registration date', 'Price'],
    columnSorting: true,
    height: 'auto',
    autoWrapRow: true,
    autoWrapCol: true,
    columns: [
      {
        type: 'text',
      },
      {
        // 2nd cell is simple text, no special options here
      },
      {
        type: 'time',
        timeFormat: 'h:mm:ss a',
        correctFormat: true,
      },
      {
        type: 'numeric',
        numericFormat: {
          pattern: '$ 0,0.00',
        },
      },
    ]
  };

  ngAfterViewInit(): void {
    this.hotTable.hotInstance?.validateCells();
  }
}



/* file: app.module.ts */
import { NgModule, ApplicationConfig } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, HotTableModule } from '@handsontable/angular-wrapper';
import { CommonModule } from '@angular/common';
import { NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';
import { Example1TimeCellTypeComponent } from './app.component';

// register Handsontable's modules
registerAllModules();

export const appConfig: ApplicationConfig = {
  providers: [
    {
      provide: HOT_GLOBAL_CONFIG,
      useValue: {
        themeName: 'ht-theme-main',
        license: NON_COMMERCIAL_LICENSE,
      } as HotGlobalConfig
    }
  ],
};

@NgModule({
  imports: [ BrowserModule, HotTableModule, CommonModule ],
  declarations: [ Example1TimeCellTypeComponent ],
  providers: [...appConfig.providers],
  bootstrap: [ Example1TimeCellTypeComponent ]
})

export class AppModule { }